
# Live Audio Room Kit

**Live Audio Room Kit** is a prebuilt component that helps you to build full-featured live audio rooms into your apps easier.

And it includes the business logic along with the UI, enabling you to customize your live audio apps faster with more flexibility. 

>
>
>If you find this package helpful, please help by giving it a 👍 on pub.dev↗️!
>
>Your support and encouragement motivate us to continue improving and maintaining this package.
>
>Thank you for recognizing our work! 👏👏

---

# When do you need the Live Audio Room Kit
- When you want to build live audio rooms easier and faster, it allows you:
  - Build or prototype live audio apps ASAP
  - Finish the integration in the shortest possible time
- When you want to customize UI and features as needed, it allows you:
  - Customize features based on actual business needs
  - Spend less time wasted developing basic features
  - Add or remove features accordingly

# Embedded features
- Ready-to-use Live Audio Room
- Remove speakers
- Speaker seats changing & management
- Customizable seat layout
- Extendable menu bar
- Device management
- Customizable UI style
- Real-time interactive text chat
- Seat-taking (Invite & apply to take speaker seats)

## Documentation

- [APIs](https://pub.dev/documentation/zego_uikit_prebuilt_live_audio_room/latest/topics/APIs-topic.html)
- [Events](https://pub.dev/documentation/zego_uikit_prebuilt_live_audio_room/latest/topics/Events-topic.html)
- [Configs](https://pub.dev/documentation/zego_uikit_prebuilt_live_audio_room/latest/topics/Configs-topic.html)

> 
> 

- [Quick start](https://docs.zegocloud.com/article/15079)
- Customize Features
  - [Set avatar for users](https://docs.zegocloud.com/article/16259)
  - [Customize the seats](https://docs.zegocloud.com/article/16255)
  - [Customize the seat-taking logic](https://docs.zegocloud.com/article/16270)
  - [Customize the background](https://docs.zegocloud.com/article/16265)
  - [Customize user attributes](https://docs.zegocloud.com/article/16273)
  - [Set a leave confirmation dialog](https://docs.zegocloud.com/article/16284)
  - [Modify user interface text](https://docs.zegocloud.com/article/16279)
  - [Customize the bottom menu bar buttons](https://docs.zegocloud.com/article/16288)
  - [Customize the text message UI](https://docs.zegocloud.com/article/16292)
- Advanced Features
  - [Integrate Minigame](https://docs.zegocloud.com/article/16744)
  - [Minimize audio room window](https://docs.zegocloud.com/article/16179)
  - [Sharing Media](https://docs.zegocloud.com/article/16407)
  - [Send virtual gifts](https://docs.zegocloud.com/article/16819)

## Migration Guides

- [Migrating to 3.0.0](https://pub.dev/documentation/zego_uikit_prebuilt_live_audio_room/latest/topics/Migration_v3.x-topic.html#30).
- [Migrating from 3.1.0 to 3.1.1](https://pub.dev/documentation/zego_uikit_prebuilt_live_audio_room/latest/topics/Migration_v3.x-topic.html#311).

## More

[Sample Code](https://github.com/ZEGOCLOUD/zego_uikit_prebuilt_live_audio_room_example_flutter)

<br />

[Please visit our official website for more details.](https://docs.zegocloud.com/article/15073)